/*
Progettare un programma C che legge da stdin fino ad EOF
e stampa in output il numero di occorrenze delle cifre nel testo
solo per le cifre che occorrono almeno una volta nel testo.

Si puo' assumere che al piu' si leggono 1000 caratteri.
*/

#include <stdio.h>
#include <ctype.h>
#define MAX 1000
#define CIFRE 10

void acquisisciTesto(char * T)
	{
	int c,i;
		
	for(i=0;i<MAX && (c=getchar())!=EOF;i++)
		T[i] = c;

	T[i]='\0';
	}



void contaOccorrenze(char *T, int *S)
	{
	int i;

	for(i=0;T[i]!='\0';i++)
		if(isdigit(T[i]))
			S[T[i]-'0']++;
	}



void stampaOccorrenze(int *S)
	{
	int i;

	for(i=0;i<CIFRE;i++)
		if(S[i]!=0)
			printf("%d %d\n",i,S[i]);

	}

int main()
{
char Testo[MAX+1] = {0};
int Occorrenze[CIFRE]={0};

acquisisciTesto(Testo);

contaOccorrenze(Testo,Occorrenze);

stampaOccorrenze(Occorrenze);

return 0;
}
