/*Progettare un programma C che 
legge da standard input una linea di testo e stampa in output le
parole contenute nella linea in ordine inverso.
*/

#include <stdio.h>
#define MAX 1001

void leggiRiga(char *r,int * dim);
void stampaParola(char *r);
void stampa_al_contrario(char *r, int dim);

int main()
{
   char Riga[MAX];
   int dimensione=0;
   
   leggiRiga(Riga,&dimensione);

   stampa_al_contrario(Riga,dimensione);

   return 0;
}


void leggiRiga(char *r,int *dim)
{
int c;

   c = getchar();
   (*dim)++;

   if(c=='\n'||c==EOF)
      *r='\0';
   else
   {
   *r = c;
   leggiRiga(++r,dim);
   }
}


void stampa_al_contrario(char *r, int dim)
{
int i;

   for(i=dim;i>=0;i--)
   {
      if(r[i]==' ') {
         stampaParola(r + i + 1);
         putchar('\n');
      }
   }

   stampaParola(r + i + 1);
   putchar('\n');

}

void stampaParola(char *r)
{
   if(*r!='\0'&&*r!=' ')
   {
      putchar(*r);
      stampaParola(r+1);
   }
}

