/*Progettare un programma C che 
legge da standard input due linee di testo
e stampa su sdtout il numero di posizioni in cui
le linee differiscono.
Vengono considerate solo le posizioni in cui almeno
una linea ha un carattere non spazio (diverso da blank, newline, etc).
*/

#include<stdio.h>
#define MAX 1000

void leggiRiga(char *r,int lim);
void stampaPosDiff(char *r1, char *r2);

int main()
{
char Riga1[MAX] = {0},
     Riga2[MAX] = {0};

leggiRiga(Riga1,MAX);
leggiRiga(Riga2,MAX);

stampaPosDiff(Riga1,Riga2);

return 0;
}


void leggiRiga(char *r,int lim)
	{
	int i,c;

	for(i=0;i<lim&&(c=getchar())!='\n'&&c!=EOF;i++)
		r[i] = c;
	r[i]='\0';
	}


void stampaPosDiff(char *r1, char *r2)
	{
	int i,
	    numpos;

	numpos=0;

	for(i=0;r1[i]!='\0'&&r2[i]!='\0';i++)
		if(r1[i]!=r2[i]) numpos++;

	if(r1[i]==0)
		for(;r2[i]!='\0';i++)
			numpos++;

	if(r2[i]==0)
		for(;r1[i]!='\0';i++)
			numpos++;	

	printf("%d",numpos);
	}