/*
Progettare un programma C che legge da stdin
un albero binario di interi in preordine, e verifica se
la somma dei valori pari e dei valori dispari contenuti
nei nodi dell'albero sia o meno uguale.
*/

#include <stdio.h>
#include <stdlib.h>


struct nodotree {

        struct nodotree * Left;
        int Info;
        struct nodotree * Right;
        };

typedef struct nodotree NodoTree;
typedef NodoTree * PtrTree;

PtrTree creaElemento(void);
PtrTree leggiPreOrdine(void);
void sommaValori(PtrTree T);

int SommaPari = 0, 
    SommaDispari = 0;

int main()
{
PtrTree MyTree = NULL;

   MyTree = leggiPreOrdine();
   sommaValori(MyTree);

   if(SommaPari == SommaDispari)
      printf("TRUE");
   else
      printf("FALSE");

return 0;
}

PtrTree creaElemento(void)
   {
      return (PtrTree)malloc(sizeof(NodoTree));
   }

PtrTree leggiPreOrdine(void)
   {
   PtrTree Nuovo;
   int etichetta;
   int NumeroFigli;

      scanf("%d %d",&NumeroFigli,&etichetta);

      Nuovo = creaElemento();

      Nuovo->Info=etichetta;

      if(NumeroFigli==2) {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right=leggiPreOrdine();
         }
      else
         if(NumeroFigli==1) {
            Nuovo->Left=leggiPreOrdine();
            Nuovo->Right = NULL;
            }
         else {
            Nuovo->Left=NULL;
            Nuovo->Right = NULL;
            }


      return Nuovo;

 }

void sommaValori(PtrTree T)
{
   if(T!=NULL) {

      if(T->Info%2 == 0)
         SommaPari = SommaPari + T->Info;
      else
         SommaDispari = SommaDispari + T->Info;
      
      sommaValori(T->Left);
      sommaValori(T->Right);
   }

} 

