/*
Progettare un programma C che 
legge da standard input due interi x e y, due sequenze
ordinate di rispettivamente x e y interi e stampa su standard 
output l'intersezione (ordinata) delle sequenze. 
*/


#include <stdio.h>
#include <stdlib.h>

void stampaIntersezione(int *s, int *p, int dim1, int dim2);
void leggiSequenza(int *s, int dim);


int main()
{
int x,y,
    *sequenza1, *sequenza2;

   scanf("%d%d",&x,&y);

   sequenza1 = (int*)malloc(sizeof(int)*x);
   sequenza2 = (int*)malloc(sizeof(int)*y);

   leggiSequenza(sequenza1,x);
   leggiSequenza(sequenza2,y);

   stampaIntersezione(sequenza1,sequenza2,x,y);

}



void leggiSequenza(int *s, int dim)
{
int i;

   for(i=0; i<=dim-1; i++)
      scanf("%d",&s[i]);
}

void stampaIntersezione(int *s, int *p, int dim1, int dim2)
{
int i,j,trovato=0;

for(i=0; i<=dim1-1; i++) {
   j=0;
   trovato = 0;
   while(j<= dim2 - 1 && !trovato)
   {
      if(s[i] == p[j]) {
         printf("%d\n",s[i]);
         trovato = 1;
      }
      
      j++;
   }
}

}