/*
Progettare un programma C che 
legge in preordine da stdin un albero binario T etichettato con caratteri
e stampa in preorder su sdtout l'albero ottenuto da T
cancellando tutte le foglie.
*/

#include <stdlib.h>
#include <stdio.h>
#include "tree.h"

PtrNodo cancellaFoglie(PtrNodo t);
PtrNodo creaElemento(void);
PtrNodo leggiPreOrder(void);
void stampaPostOrder(PtrNodo t);

int main()
{
PtrNodo t;
   
   t = leggiPreOrder();
   t = cancellaFoglie(t);
   stampaPostOrder(t);

      return 0;
}



PtrNodo creaElemento(void)
{
return (PtrNodo)malloc(sizeof(NodoTree));
}

PtrNodo leggiPreOrder(void)
{
PtrNodo nuovo;
int x,numfigli;

   scanf("%d %c", &numfigli, &x);
   nuovo = creaElemento();

   if(nuovo==NULL)
      printf("memoria insufficiente");
   else
   {
      nuovo->Info = x;

      if(numfigli==2) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = leggiPreOrder();
      }
      
      if(numfigli==1) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = NULL;
      }
    
      if(numfigli==0) {
         nuovo->Left = nuovo->Right = NULL;
      }  
   }
   return nuovo;
}


PtrNodo cancellaFoglie(PtrNodo t)
{
   if(t->Left==NULL&&t->Right==NULL) {
      free(t);
      return NULL;
   }

  
   t->Left = cancellaFoglie(t->Left);
   t->Right = cancellaFoglie(t->Right);
   return t;

}

void stampaPostOrder(PtrNodo t)
{
   if(t!=NULL)
   {
      printf("%c\n",t->Info);
      stampaPostOrder(t->Left);
      stampaPostOrder(t->Right);
   }
}
