/*
Progettare un programma C che 
legge in preordine da stdin un albero binario T etichettato con caratteri
e stampa in postorder su sdtout l'albero ottenuto da T
sommando 1 a tutte le cifre pari e sottraendo 1 a tutte le cifre
dispari.
I caratteri che non rappresentano cifre restano inalterati.
*/

#include <stdio.h>
#include <stdlib.h>
#include "tree.h"


PtrNodo creaElemento(void),
        leggiPreOrder(void);
        

void ModificaEtichette(PtrNodo);
void stampaPostOrder(PtrNodo);

int main()
{
PtrNodo MyTree;

   MyTree = leggiPreOrder();
   ModificaEtichette(MyTree);
   stampaPostOrder(MyTree);
}

PtrNodo creaElemento(void)
{
return (PtrNodo)malloc(sizeof(NodoTree));
}

PtrNodo leggiPreOrder(void)
{
PtrNodo nuovo;
int x,numfigli;

   scanf("%d %c", &numfigli, &x);
   nuovo = creaElemento();

   if(nuovo==NULL)
      printf("memoria insufficiente");
   else
   {
      nuovo->Info = x;

      if(numfigli==2) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = leggiPreOrder();
      }
      
      if(numfigli==1) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = NULL;
      }
    
      if(numfigli==0) {
         nuovo->Left = nuovo->Right = NULL;
      }  
   }
   return nuovo;
}



void ModificaEtichette(PtrNodo t)
{
int cifra;

   if(t!=NULL)
   {
      if(isdigit(t->Info)) {

         cifra = t->Info - '0';
      
         if(cifra%2==0)
            t->Info = t->Info + 1;
         else
            t->Info = t->Info - 1;
      }

      ModificaEtichette(t->Left);
      ModificaEtichette(t->Right);
   }
}

void stampaPostOrder(PtrNodo t)
{
   if(t!=NULL)
   {
      stampaPostOrder(t->Left);
      stampaPostOrder(t->Right);
      printf("%c\n",t->Info);
   }
}


