/*
Progettare un programma C che 
legge da standard input una linea di testo di al piu' 1024 caratteri, e stampa 
su stdout i caratteri alfabetici della linea dopo averli ordinati in ordine alfabetico. 
Lo studente puo' assumere che i caratteri alfabetici siano tutti minuscoli.
*/

#include <stdio.h>
#define MAX 1024

int leggi(char *l);
void ordina(char *l, int dim);
void stampa(char *l,int dim);

int main()
{
char linea_testo[MAX+1]={0};
int dimensione;

dimensione = leggi(linea_testo);
ordina(linea_testo, dimensione);
stampa(linea_testo,dimensione);
}

int leggi(char *l)
{
int i,c;

   for(i=0; i<MAX-1&&(c=getchar())!=EOF&&c!='\n';)
   {
   if(isalpha(c)) l[i++] = c; 
   }

l[i] = '\0';
return i;
}


void ordina(char *l, int dim)
{
int i,j,temp;

for(i=1;i<=dim-1;i++)
   for(j=0; j <= dim -2; j++)
      if(l[j] > l[j+1]) {
         temp = l[j];
         l[j] = l[j+1];
         l[j+1] = temp;
      }  
}

void stampa(char *l,int dim)
{
int i;

   for(i=0;i<=dim-1;i++)
      printf("%c",l[i]);
}