/*Progettare un programma C che legge da stdin una parola p
(cioe' una stringa senza blanks) ed una
sequenza di caratteri T (testo) fino ad EOF.
Il programma stampa su stdout il numero di occorrenze 
della parola p come parola nel testo T.
Cioe' contiamo le occorrenze di p che 
non sono precedute o seguite da un carattere alfanumerico.

Si puo' assumere che al piu' si leggono 1000 caratteri.
*/

#include <stdio.h>
#include <ctype.h>
#define MAX 1001



void leggiParola(char *P,int lim);
void leggiTesto(char *T, int lim);
int numeroOccorrenze(char *P, char * T);


int main()
{
char Parola[MAX]={'\0'},
     Testo[MAX]={'\0'};

int numero;

leggiParola(Parola,MAX);

leggiTesto(Testo,MAX);

numero = numeroOccorrenze(Parola,Testo);

printf("%d",numero);


return;
}



void leggiParola(char *P,int lim)
	{
	int i;
	char c;

	for(i=0;i<lim&&(c=getchar())!=' '&&c!='\n';i++)
		P[i]=c;

	P[i]='\0';

	}

void leggiTesto(char *T, int lim)
	{
	int i;
	char c;


	for(i=0;i<lim&&(c=getchar())!=EOF;i++)
		T[i]=c;

	T[i]='\0';

	}


int numeroOccorrenze(char *P, char * T)
	{
	int n=0;
	int i=0,j=0;

	while(T[i]!='\0')
		{
		
		j=0;

		for(j=0;P[j]==T[i+j]&&P[j]!='\0';j++);

		if(P[j]=='\0')
			if(i==0&&!isalnum(T[i+j])) n++;
				else
				if(T[i+j]=='\0'&&!isalnum(T[i-1])) n++;
					else
					if(!isalnum(T[i-1])&&!isalnum(T[i+j])) n++;
		
		i++;				
		}

	return n;

	}
