/*
Progettare un programma C che 
legge da stdin un albero binario in preordine e lo stampa su stdout
in postordine moltiplicando per r i valori delle etichette dei nodi,
dove r e' l'etichetta del padre del nodo.
La radice dell'albero resta invariata.
*/

#include <stdio.h>
#include <stdlib.h>

struct nodotree {

        struct nodotree * Left;
        int Info;
        struct nodotree * Right;
        };



typedef struct nodotree NodoTree;
typedef NodoTree * PtrNodoTree;

void modificaEtichette(PtrNodoTree Tree, int radice);

void stampaPostOrdineR(PtrNodoTree Tree);
PtrNodoTree leggiPreOrdine(void),
            creaElemento(void);


void main()
   {
      PtrNodoTree MyTree;

      MyTree = leggiPreOrdine();
	
	modificaEtichette(MyTree, 1);

      stampaPostOrdineR(MyTree);
   }

PtrNodoTree creaElemento(void)
   {
      return (PtrNodoTree)malloc(sizeof(NodoTree));
   }



PtrNodoTree leggiPreOrdine(void)
   {
   PtrNodoTree Nuovo;
   int val;
   int NumeroFigli;

      scanf("%d %d",&NumeroFigli,&val);

      Nuovo = creaElemento();

      Nuovo->Info=val;

      if(NumeroFigli==2) {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right=leggiPreOrdine();
         }
      else
         if(NumeroFigli==1) {
            Nuovo->Left=leggiPreOrdine();
            Nuovo->Right = NULL;
            }
         else {
            Nuovo->Left=NULL;
            Nuovo->Right = NULL;
            }


      return Nuovo;

 }


void modificaEtichette(PtrNodoTree Tree, int radice)
{
   if(Tree!=NULL)
   {
	
      modificaEtichette(Tree->Left, Tree->Info);
      modificaEtichette(Tree->Right, Tree->Info);
      Tree->Info = Tree->Info * radice;
      
   } 
}


void stampaPostOrdineR(PtrNodoTree Tree)
   {
      if(Tree!=NULL)
      {	
         stampaPostOrdineR(Tree->Left);
         stampaPostOrdineR(Tree->Right);
         printf("%d\n",Tree->Info);
      }
   }