/*
Progettare un programma C che 
legga in preordine da stdin un albero binario di interi T e
verifichi se e' vero che la radice di ogni sottoalbero sia
l'elemento piu' grande del sottoalbero.
*/

#include <stdio.h>
#include <stdlib.h>


struct nodotree {
   struct nodotree *Left;
   int Info;
   struct nodotree *Right;
};

typedef struct nodotree NodoTree;
typedef NodoTree *PtrNodo;

PtrNodo creaElemento(void);
PtrNodo leggiPreOrder(void);
int verifica(PtrNodo t, int radice);

int main()
{
PtrNodo t;

   t = leggiPreOrder();

   if(verifica(t,t->Info+1))
      printf("TRUE");
   else
      printf("FALSE");

      return 0;
}

PtrNodo creaElemento(void)
{
return (PtrNodo)malloc(sizeof(NodoTree));
}

PtrNodo leggiPreOrder(void)
{
PtrNodo nuovo;
int x,numfigli;

   scanf("%d %d", &numfigli, &x);
   nuovo = creaElemento();

   if(nuovo==NULL)
      printf("memoria insufficiente");
   else
   {
      nuovo->Info = x;

      if(numfigli==2) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = leggiPreOrder();
      }
      
      if(numfigli==1) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = NULL;
      }
    
      if(numfigli==0) {
         nuovo->Left = nuovo->Right = NULL;
      }  
   }
   return nuovo;
}


int verifica(PtrNodo t, int radice)
{
   int a,b;

   if(t==NULL)
      return 1;
   
   a = verifica(t->Left, t->Info);
   b = verifica(t->Right, t->Info);
   
   if(a==1 && b==1 && t->Info < radice)
      return 1;
   else
      return 0;
}

