/*
Progettare un programma C che 
legge da input due interi low e up e un albero binario T di interi
(in preordine) e stampa il numero di elementi con valore
nell'intervallo low, up estremi compresi.
*/

#include <stdio.h>
#include <stdlib.h>


struct nodotree {
   struct nodotree *Left;
   int Info;
   struct nodotree *Right;
};

typedef struct nodotree NodoTree;
typedef NodoTree *PtrNodo;

PtrNodo creaElemento(void);
PtrNodo leggiPreOrder(void);
void ContaElementi(PtrNodo t, int low, int up,int *numero);

int main()
{
int low,up,num=0;
PtrNodo t;

   scanf("%d%d",&low,&up);
   t = leggiPreOrder();

   ContaElementi(t,low,up,&num);

   printf("%d",num);

      return 0;
}




PtrNodo creaElemento(void)
{
return (PtrNodo)malloc(sizeof(NodoTree));
}

PtrNodo leggiPreOrder(void)
{
PtrNodo nuovo;
int x,numfigli;

   scanf("%d %d", &numfigli, &x);
   nuovo = creaElemento();

   if(nuovo==NULL)
      printf("memoria insufficiente");
   else
   {
      nuovo->Info = x;

      if(numfigli==2) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = leggiPreOrder();
      }
      
      if(numfigli==1) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = NULL;
      }
    
      if(numfigli==0) {
         nuovo->Left = nuovo->Right = NULL;
      }  
   }
   return nuovo;
}


void ContaElementi(PtrNodo t, int low, int up, int *numero)
{

   if(t!=NULL)
   {
      if(t->Info >= low && t->Info <= up)
          *numero = *numero + 1;

      ContaElementi(t->Left,low,up,numero);
      ContaElementi(t->Right,low,up,numero);
   }

}